freeslot("MT_SPDBUFF", "MT_RNGBUFF", "MT_CLDBUFF", "S_BUFF1", "S_BUFF2", "S_BUFF3", "SPR_BUFF")

mobjinfo[MT_SPDBUFF] = {
	spawnstate = S_BUFF1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL,
}

mobjinfo[MT_RNGBUFF] = {
	spawnstate = S_BUFF2,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL,
}

mobjinfo[MT_CLDBUFF] = {
	spawnstate = S_BUFF3,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SPECIAL,
}

states[S_BUFF1] = {SPR_BUFF, FF_PAPERSPRITE|A, 1050, nil, 0, 0, S_NULL}
states[S_BUFF2] = {SPR_BUFF, FF_PAPERSPRITE|B, 1050, nil, 0, 0, S_NULL}
states[S_BUFF3] = {SPR_BUFF, FF_PAPERSPRITE|C, 1050, nil, 0, 0, S_NULL}

for i = MT_SPDBUFF, MT_CLDBUFF
	addHook("MobjThinker", function(mo)
		mo.angle = $+ANG2
	end, i)
end

local function sparkle(mo)
	for i = 1, 15
		local spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
		spark.momx = P_RandomRange(-20, 20)*FRACUNIT
		spark.momy = P_RandomRange(-20, 20)*FRACUNIT
		spark.momz = P_RandomRange(-20, 20)*FRACUNIT
	end
end

addHook("TouchSpecial", function(s, t)
	if t and t.valid and t.player and t.buffs
		S_StartSound(s, sfx_s1c3)
		sparkle(s)

		K_PlayPowerGloatSound(t)
		t.buffs.speed = $+1
	end
end, MT_SPDBUFF)

addHook("TouchSpecial", function(s, t)
	if t and t.valid and t.player and t.buffs
		S_StartSound(s, sfx_s1c3)
		sparkle(s)

		K_PlayPowerGloatSound(t)
		t.buffs.range = $+1
	end
end, MT_RNGBUFF)

addHook("TouchSpecial", function(s, t)
	if t and t.valid and t.player and t.buffs
		S_StartSound(s, sfx_s1c3)
		sparkle(s)

		K_PlayPowerGloatSound(t)
		t.buffs.cooldown = $+1
	end
end, MT_CLDBUFF)

local buffMo = {MT_RNGBUFF, MT_CLDBUFF, MT_SPDBUFF}
rawset(_G, "randBuff", function()
	return buffMo[P_RandomRange(1, #buffMo)]
end)