freeslot("MT_BR_BOMB", "S_BR_BOMB1", "S_BR_BOMB2", "S_BR_BOMB3", "S_BR_BOMB4", "S_BR_BOMB_DANGEROUS", "SPR_BRBM")

mobjinfo[MT_BR_BOMB] = {
    spawnstate = S_BR_BOMB1,
    radius = 30*FRACUNIT,
    height = 30*FRACUNIT,
    flags = MF_SOLID|MF_BOUNCE
}

states[S_BR_BOMB1] = {SPR_BRBM, E, -1, nil, 0, 0, S_BR_BOMB1}
states[S_BR_BOMB2] = {SPR_BRBM, G, 5, nil, 0, 0, S_BR_BOMB3}
states[S_BR_BOMB3] = {SPR_BRBM, H, 35, nil, 0, 0, S_BR_BOMB4}
states[S_BR_BOMB4] = {SPR_BRBM, J, 10, nil, 0, 0, S_BR_BOMB_DANGEROUS}
states[S_BR_BOMB_DANGEROUS] = {SPR_BRBM, A, -1, nil, 0, 0, S_BR_BOMB_DANGEROUS}

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		bombThinker(mo)
	end
end, MT_BR_BOMB)

rawset(_G, "BOMB_NORMAL", 1)
rawset(_G, "BOMB_INSTA", 2)
rawset(_G, "BOMB_HUGE", 3)
rawset(_G, "BOMB_GRAVITY", 4)
rawset(_G, "BOMB_FIRE", 5)
rawset(_G, "BOMB_NUKE", 6)
rawset(_G, "BOMB_INSTANUKE", 7)

rawset(_G, "bombSetUp", function(mo)
	local bombChance = {
		1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
		2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
		3, 3, 3, 3, 3, 3,
		4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
		5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
		6, 6, 6,
		7,
	}
	
	mo.bombtype = bombChance[P_RandomRange(1, #bombChance)]
	local w = P_SpawnMobj(mo.x, mo.y, mo.floorz - 30*FRACUNIT, MT_THOK)
	w.color = SKINCOLOR_RED
	w.tics = -1
	w.fuse = -1
	w.scale = 13*FRACUNIT
	w.frame = FF_FULLBRIGHT|FF_TRANS40|A
	w.flags2 = $|MF2_DONTDRAW
	
	mo.explodetimer = 10*TICRATE
	mo.color = SKINCOLOR_RED
	if mo.bombtype == BOMB_INSTA
		mo.color = SKINCOLOR_GREY
		mo.colorized = true
		w.scale = 13*FRACUNIT
	elseif mo.bombtype == BOMB_HUGE
		mo.explodetimer = 15*TICRATE
		mo.scale = 3*FRACUNIT
		w.scale = 21*FRACUNIT
	elseif mo.bombtype == BOMB_GRAVITY
		mo.explodetimer = 15*TICRATE
		mo.color = SKINCOLOR_BLUE
		mo.colorized = true
		w.scale = 9*FRACUNIT
	elseif mo.bombtype == BOMB_FIRE
		mo.explodetimer = 15*TICRATE
		mo.color = SKINCOLOR_KETCHUP
		mo.colorized = true
		w.scale = 13*FRACUNIT
	elseif mo.bombtype == BOMB_NUKE
		mo.scale = 8*FRACUNIT
		w.scale = 109*FRACUNIT

		mo.explodetimer = 30*TICRATE
		mo.color = SKINCOLOR_GREEN
		mo.colorized = true
	elseif mo.bombtype == BOMB_INSTANUKE
		mo.scale = 8*FRACUNIT
		w.scale = 109*FRACUNIT

		mo.explodetimer = 30*TICRATE
		mo.color = SKINCOLOR_LEMONADE
		mo.colorized = true
	end
	
	mo.warning = w
end)

rawset(_G, "bombThinker", function(mo)
	if (server.gamemode ~= GM_BOMBRAIN) then return end
	
	if not mo.bombtype
		bombSetUp(mo)
		return
	end
	
	if P_IsObjectOnGround(mo) and mo.bombtype == BOMB_INSTA
		explodeBomb(mo, mo.bombtype)
		P_RemoveMobj(mo)
		return
	elseif not P_IsObjectOnGround(mo) and mo.bombtype == BOMB_NUKE
		mo.momz = -7*FRACUNIT
		P_SpawnGhostMobj(mo)
	elseif mo.bombtype == BOMB_INSTANUKE
		if P_IsObjectOnGround(mo)
			explodeBomb(mo, mo.bombtype)
			P_RemoveMobj(mo)
			return
		else
			mo.momz = -4*FRACUNIT
			P_SpawnGhostMobj(mo)
		end
	end
	
	if mo and mo.valid
		if mo.state == S_BR_BOMB_DANGEROUS
			if mo.warning
				mo.warning.flags2 = $ & ~MF2_DONTDRAW
			end

			if mo.bombtype ~= BOMB_HUGE and mo.bombtype ~= BOMB_GRAVITY and mo.bombtype ~= BOMB_NUKE
				for p in players.iterate
					if validP(p)
						local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)
						
						if dist < 185*FRACUNIT
							explodeBomb(mo, mo.bombtype)
							P_RemoveMobj(mo)
							return
						end
					end
				end
			end				
			
			mo.explodetimer = $-1
			if mo.explodetimer <= 0
				explodeBomb(mo, mo.bombtype)
				P_RemoveMobj(mo)
				return
			end
		elseif mo.state == S_BR_BOMB1 and P_IsObjectOnGround(mo)
			if mo.bombtype == BOMB_NUKE or mo.bombtype == BOMB_HUGE
				P_StartQuake(7*FRACUNIT, 10)
				S_StartSound(mo, sfx_pstop)
			else
				S_StartSound(mo, sfx_bossdm)
			end

			mo.state = S_BR_BOMB2
		end
	end
end)

rawset(_G, "explodeBomb", function(mo, bomb)	
	if mo and mo.valid
		if mo.warning and mo.warning.valid
			P_RemoveMobj(mo.warning)
			mo.warning = nil
		end
 
		if bomb == BOMB_HUGE
			K_SpawnKartExplosion(mo.x, mo.y, mo.z, 460*FRACUNIT, 10)
			K_SpawnMineExplosion(mo, SKINCOLOR_KETCHUP)

			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 800*FRACUNIT
						p.kartstuff[k_bumper] = $-1
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 5*FRACUNIT)
					end
				end
			end
		elseif bomb == BOMB_NUKE // should instakill
			K_SpawnKartExplosion(mo.x, mo.y, mo.z, 1500*FRACUNIT, 5)	
			K_SpawnMineExplosion(mo, SKINCOLOR_JET)

			for i = 1, 8
				local dummy = P_SpawnMobj(mo.x+200*cos(mo.angle+ANGLE_45*i),
											mo.y+200*sin(mo.angle+ANGLE_45*i),
											mo.z, MT_THOK)
				
				dummy.scale = 4*FRACUNIT
				dummy.color = SKINCOLOR_RED
			end
			
			P_StartQuake(10*FRACUNIT, 5*TICRATE)

			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 3500*FRACUNIT
						p.kartstuff[k_bumper] = $-3
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 40*FRACUNIT)
					end
				end
			end
		elseif bomb == BOMB_INSTANUKE
			K_SpawnKartExplosion(mo.x, mo.y, mo.z, 1500*FRACUNIT, 5)	
			K_SpawnMineExplosion(mo, SKINCOLOR_JET)

			for i = 1, 8
				local dummy = P_SpawnMobj(mo.x+200*cos(mo.angle+ANGLE_45*i),
											mo.y+200*sin(mo.angle+ANGLE_45*i),
											mo.z, MT_THOK)
				
				dummy.scale = 4*FRACUNIT
				dummy.color = SKINCOLOR_RED
			end
			
			P_StartQuake(10*FRACUNIT, 5*TICRATE)

			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 3000*FRACUNIT
						p.kartstuff[k_bumper] = $-1
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 40*FRACUNIT)
					end
				end
			end
		elseif bomb == BOMB_GRAVITY
			K_SpawnMineExplosion(mo, SKINCOLOR_PURPLE)
			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 300*FRACUNIT
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 100*FRACUNIT)
					end
				end
			end
		elseif bomb == BOMB_FIRE
			K_SpawnMineExplosion(mo, SKINCOLOR_KETCHUP)

			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 250*FRACUNIT
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 20*FRACUNIT)
					end
				end
			end

			A_NapalmScatter(mo, MT_CYBRAKDEMON_FLAMEREST+(12<<16), 128+(40<<16))
			A_NapalmScatter(mo, MT_CYBRAKDEMON_FLAMEREST+(1<<16), 24<<16)
		else
			K_SpawnKartExplosion(mo.x, mo.y, mo.z, 200*FRACUNIT)
			K_SpawnMineExplosion(mo, SKINCOLOR_RED)

			for p in players.iterate
				if validP(p)
					local dist = R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y)

					if dist < 400*FRACUNIT
						P_DamageMobj(p.mo, mo)
						P_InstaThrust(p.mo, 0, 0)
						P_SetObjectMomZ(p.mo, 20*FRACUNIT)
					end
				end
			end
		end
	end
end)

local function bombRain()
	if (server.gamemode == GM_BOMBRAIN) and (leveltime > 8*TICRATE)
		local possiblePlayers = {}

		for p in players.iterate
			if validP(p) then table.insert(possiblePlayers, p.mo) end
		end

		local inc = 20
		if (leveltime >= 68*TICRATE) then
			inc = 5
		elseif (leveltime >= 38*TICRATE) then
			inc = 10
		end

		if #possiblePlayers and not (leveltime%inc)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]

			local bomb = P_SpawnMobj(tmo.x+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.y+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_BR_BOMB)
			bomb.angle = P_RandomRange(0, 360)*ANG1
			bombSetUp(bomb)
		end
	end
	
	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		p.hp = $ or 100

		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		playersLeft[1].marescore = 69420
		for p in players.iterate
			if p.boxdata.out == true
				p.marescore = p.boxdata.survivaltime or 0
			else
				p.marescore = 69420
			end
		end
		
		BX_EndBattle()
		server.ended = true
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("CRUSHR")
		showMusicCredit()
	end
end

local function bombRainDamage(p, inf, src)
	if p.mo and p.mo.valid and p.boxdata
		if p.boxdata.out == true then return true end
		
		if p.kartstuff[k_bumper] <= 1
			print(p.name.." was blown up.")
			p.boxdata.out = true
			p.boxdata.survivaltime = G_TicsToSeconds(leveltime-8*TICRATE)

			K_PlayLossSound(p.mo)
		end
	end
end

local function bombHud(v, p, cam)
	for mo in thinkers.iterate("mobj")
		if mo.type == MT_BR_BOMB
		and (mo.type == BOMB_INSTA or mo.type == BOMB_INSTANUKE)
			v.drawOnMinimap(mo.x, mo.y, FRACUNIT, v.cachePatch("YIKES"))
		end
	end
end

-- we'll also increase the framerate for this mode cause its laggy as shit lol
addHook("MobjSpawn", function(mo)
   	if not G_BattleGametype() then return end
	if server.gametype ~= GM_BOMBRAIN then return end

	mo.flags2 = $|MF2_DONTDRAW
end, MT_SMOKE)

Box.Gamemodes[GM_BOMBRAIN] = {
	name = "Raining Explosives",
	hint = "Be the last one standing!",
	thinker = bombRain,
	damagefunc = bombRainDamage,
	spinoutfunc = bombRainDamage,
	squishfunc = bombRainDamage,
	explodefunc = bombRainDamage,
	hudfunc = bombHud
}