local function crumbleThinker()
	server.removesectors = $ or {}

	if not (leveltime%285) and (leveltime > 6*TICRATE)
		S_StartSound(nil, sfx_s3kd6l)

		local sectorNums = {}
		for s in sectors.iterate
			if s.floorpic ~= "LAVAR1_1"
				table.insert(sectorNums, #s)
			end
		end

		local num
		for i = 1, 25 do
			num = sectorNums[P_RandomRange(1, #sectorNums)]
			table.insert(server.removesectors, num)
			sectors[num].floorpic = "REDNOISE"
		end

		server.killtimer = 3*TICRATE
	end
	
	if server.killtimer then
		server.killtimer = $-1

		if server.killtimer <= 0 then
			S_StartSound(nil, sfx_crumbl)
			P_StartQuake(20*FRACUNIT, TICRATE)

			for i = 1, #server.removesectors
				if server.removesectors[i] and sectors[server.removesectors[i]]
					sectors[server.removesectors[i]].floorheight = -300*FRACUNIT
					sectors[server.removesectors[i]].floorpic = "LAVAR1_1"
				end
			end
			
			for p in players.iterate
				if validP(p)
					p.kartstuff[k_itemtype] = 4
					p.kartstuff[k_itemamount] = 1
				end
			end
			
			server.killtimer = nil
		end
	end

	for p in players.iterate
		if p.spectator then continue end

		if p.mo.subsector.sector.floorpic == "LAVAR1_1" 
		and p.boxdata and p.boxdata.out == false
		and p.mo.z <= p.mo.subsector.sector.floorheight
			p.boxdata.out = true
			p.boxdata.survivaltime = G_TicsToSeconds(leveltime-5*TICRATE)
			BX_ExplodeAndRespawn(p)
			
			print(p.name.." fell into a pit.")
		end
	end
	
	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		if p.spectator then continue end

		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		playersLeft[1].marescore = 69420
		for p in players.iterate
			if p.boxdata.out == true
				p.marescore = p.boxdata.survivaltime or 0
			else
				p.marescore = 69420
			end
		end
		
		BX_EndBattle()
		server.ended = true
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("CRUMBL")
		showMusicCredit()
	end
end

local function crumblePush(p, inf, src)
	if p.mo and p.mo.valid and inf and inf.valid
		local ang = R_PointToAngle2(inf.x, inf.y, p.mo.x, p.mo.y)
		P_Thrust(p.mo, ang, 50*FRACUNIT)
	end
	
	return true
end

local function crumbleReset()
	server.removesectors = nil
	server.killtimer = nil
end

Box.Gamemodes[GM_CRUMBLE] = {
	name = "Floor Crumbling",
	hint = "Be the last one standing!",
	noBumpers = true,

	thinker = crumbleThinker,
	spinoutfunc = crumblePush,
	squishfunc = crumblePush,
	explodefunc = crumblePush,
	resetfunc = crumbleReset,
}