local function CrusherThinker()
	server.sectordropspeed = $ or {}

	for p in players.iterate
		if p.spectator then continue end

		p.kartstuff[k_itemtype] = 0
		p.kartstuff[k_itemamount] = 0
	end

	if server.gamemode == GM_CRUSHER and (leveltime == 8*TICRATE)
		S_ChangeMusic("CRUSHR")
		showMusicCredit()

		server.sectordropspeed = {}
		P_StartQuake(4*FRACUNIT, 5*TICRATE)
		for sector in sectors.iterate do
			server.sectordropspeed[#sector] = P_RandomRange(3, 9)*((FRACUNIT/2)+P_RandomFixed())
		end
	end
	
	for s in sectors.iterate
		if s and s.valid and server.sectordropspeed[#s] and s.ceilingheight > s.floorheight
			s.ceilingheight = max(s.floorheight, $-server.sectordropspeed[#s])
			if s.ceilingheight <= s.floorheight
				P_StartQuake(20*FRACUNIT, TICRATE)
			end
		end
	end
	
	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		if p.spectator then continue end

		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		for p in players.iterate
			if p.spectator then continue end

			if p.boxdata.out == true
				p.marescore = p.boxdata.survivaltime or 0
			else
				p.marescore = 69420
			end
		end
		
		BX_EndBattle()
		server.ended = true
	end
end

local function CrusherPain(p, inf, src)
	if p.mo and p.mo.valid and p.boxdata
		if p.boxdata.out == true then return true end

		print(p.name.." was squished.")
		p.boxdata.out = true
		p.boxdata.survivaltime = G_TicsToSeconds(leveltime-8*TICRATE)

		K_PlayLossSound(p.mo)
		S_StartSound(p.mo, sfx_ghit)
	end
end

local function CrusherReset()
	server.sectordropspeed = nil
end

Box.Gamemodes[GM_CRUSHER] = {
	name = "Crushers",
	hint = "Be the last one standing!",
	noBumpers = true,

	thinker = CrusherThinker,
	damagefunc = CrusherPain,
	squishfunc = CrusherPain,
	resetfunc = CrusherReset
}