local function moveThinker()
	if (leveltime > 10*TICRATE)
		for p in players.iterate
			if (p.speed < 15*p.mo.scale) and not server.ended and validP(p)
				p.boxdata.out = true
				p.boxdata.survivaltime = G_TicsToSeconds(leveltime-10*TICRATE)
				BX_ExplodeAndRespawn(p)
				
				print(p.name.." blew up for slowing down.")
			end
			
			if not (leveltime%175) and not p.kartstuff[k_itemtype] and not p.kartstuff[k_itemamount]
				local fairItems = {
					{KITEM_ORBINAUT, 3},
					{KITEM_ORBINAUT, 2},
					{KITEM_ORBINAUT, 1},
					{KITEM_BALLHOG, 1},
					{KITEM_SNEAKER, 3},
					{KITEM_SNEAKER, 1},
				}

				local itemSet = fairItems[P_RandomRange(1, #fairItems)]
				p.kartstuff[k_itemtype] = itemSet[1]
				p.kartstuff[k_itemamount] = itemSet[2]
			end
		end
	end

	-- End Terms
	local playersLeft = {}
	for p in players.iterate
		if p.boxdata.out == false
			table.insert(playersLeft, p)
		end
	end
	
	server.ended = $ or false
	if #playersLeft <= 1 and server.ended == false
		for p in players.iterate
			if not p.spectator
				if p.boxdata.out == true
					p.marescore = p.boxdata.survivaltime or 0
				else
					p.marescore = 69420
				end
			end
		end

		BX_EndBattle()
		server.ended = true
	end

	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("CRUSHR")
		showMusicCredit()
	end
end

local function moveHud(v, p, c)
	if (leveltime > 8*TICRATE) and (leveltime < 20*TICRATE)
		v.drawString(160, 185, "KEEP MOVING", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
	end
end

Box.Gamemodes[GM_MOVEORDIE] = {
	name = "Move or DIE!!!",
	hint = "Keep moving!",
	noBumpers = true,

	thinker = moveThinker,
	hudfunc = moveHud,
}