local function randomThinker()
	server.dest = $ or {}

	for p in players.iterate
		if p.spectator then continue end

		if not (leveltime%350) and p.boxdata.out == false
			p.kartstuff[k_itemroulette] = 5*TICRATE
		end
	end

	if server.gamemode == GM_RANDOMMOVEMENT 
	and ((not (leveltime%1500) and leveltime >= 5*TICRATE)
	or (leveltime == 6*TICRATE))
		P_StartQuake(40*FRACUNIT, 5*TICRATE)
		for sector in sectors.iterate do
			server.dest[#sector] = P_RandomRange(0, 1940)*FRACUNIT
		end
	end
	
	for s in sectors.iterate
		if s and s.valid and server.dest[#s] and s.floorheight ~= server.dest[#s]
			s.floorheight = $+((server.dest[#s]-s.floorheight)/40)
		end
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("RANDOM")
		showMusicCredit()
	end
end

local function randomPlayerThinker(p)
	p.mo.jumpcharge = $ or 0

	if (p.cmd.buttons & BT_DRIFT) and P_IsObjectOnGround(p.mo)
		p.mo.jumpcharge = min(100, $+1)
		
		if not (leveltime%2)
			p.mo.colorized = true
		end
	elseif not (p.cmd.buttons & BT_DRIFT) and p.mo.jumpcharge > 0
		P_SetObjectMomZ(p.mo, max(5, p.mo.jumpcharge/2)*FRACUNIT)
		S_StartSound(p.mo, sfx_s3k56)
		for i = 1, 16
			local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMOKE)
			dust.frame = A|FF_TRANS60
				
			P_InstaThrust(dust, i*2*ANG10, 10*FRACUNIT)
		end
		
		p.mo.colorized = false
		p.mo.jumpcharge = 0
	end
end

local function randomReset()
	server.dest = nil
end

local function randomHud(v, p, c)
	if (leveltime > 8*TICRATE) and (leveltime < 20*TICRATE)
		v.drawString(160, 185, "HOLD DRIFT TO JUMP", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
	end
end

Box.Gamemodes[GM_RANDOMMOVEMENT] = {
	name = "Random Sector Movement",
	hint = "Be the last one standing!",
	bumpers = 2,

	thinker = randomThinker,
	playerthinker = randomPlayerThinker,

	resetfunc = randomReset,
	hudfunc = randomHud,
}