freeslot("MT_KARTRING", "MT_BIGRING", "MT_FLUNGRING", "S_KARTRING")

mobjinfo[MT_KARTRING] = {
    spawnstate = S_KARTRING,
    radius = 30*FRACUNIT,
    height = 30*FRACUNIT,
    flags = MF_BOUNCE|MF_SPECIAL
}

mobjinfo[MT_BIGRING] = {
    spawnstate = S_KARTRING,
    radius = 28*FRACUNIT,
    height = 28*FRACUNIT,
    flags = MF_BOUNCE|MF_SPECIAL
}

mobjinfo[MT_FLUNGRING] = {
    spawnstate = S_KARTRING,
    radius = 30*FRACUNIT,
    height = 30*FRACUNIT,
    flags = MF_BOUNCE|MF_SPECIAL
}

states[S_KARTRING] = {SPR_RING, FF_ANIMATE|A, -1, nil, 23, 1, S_KARTRING}

local function ringThinker(mo)
//	mo.scale = FRACUNIT+FRACUNIT/5

	if not P_IsObjectOnGround(mo) then
		P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPARK)
		P_SpawnGhostMobj(mo)
	end
	
	/*
	if not mo.targ
		for p in players.iterate
			if R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < 80*FRACUNIT
				mo.targ = p.mo
			end
		end
	elseif mo.targ
		if mo.targ.valid
			local target = mo.targ
			local dist = P_AproxDistance(P_AproxDistance(target.x - mo.x, target.y - mo.y), target.z - mo.z)
			mo.momx = FixedMul(FixedDiv(target.x - mo.x, dist), 32<<FRACBITS)
			mo.momy = FixedMul(FixedDiv(target.y - mo.y, dist), 32<<FRACBITS)
			mo.momz = FixedMul(FixedDiv(target.z - mo.z, dist), 32<<FRACBITS)
			P_SpawnGhostMobj(mo)
		else
			mo.targ = nil
		end
	end
	*/
end

addHook("MobjThinker", function(mo)
	mo.scale = (FRACUNIT*3)/2
	ringThinker(mo)
end, MT_KARTRING)

addHook("MobjThinker", function(mo)
	mo.scale = 3*FRACUNIT
	ringThinker(mo)
end, MT_BIGRING)

addHook("MobjThinker", function(mo)
	ringThinker(mo)
	
	if mo.pickupcool
		mo.pickupcool = $-1
		if mo.pickupcool <= 0
			mo.pickupcool = nil
		end
		
		return false
	end
end, MT_FLUNGRING)

local function touchRing(ring, mo)
	if not P_IsObjectOnGround(ring) then return true end
	if ring.pickupcool then return true end

	if mo and mo.valid and ring and ring.valid and mo.player
		local p = mo.player
		if not p.kartRings then p.kartRings = 0 end
		
		p.kartRings = $+1
		S_StartSound(mo, sfx_itemup)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_RemoveMobj(ring)
	end
end

local function touchBigRing(ring, mo)
	if mo and mo.valid and ring and ring.valid and mo.player
		local p = mo.player
		if not p.kartRings then p.kartRings = 0 end
		
		p.kartRings = $+10
		S_StartSound(mo, sfx_itemup)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_RemoveMobj(ring)
	end
end

addHook("TouchSpecial", touchRing, MT_KARTRING)
addHook("TouchSpecial", touchRing, MT_FLUNGRING)

addHook("TouchSpecial", touchBigRing, MT_BIGRING)

local function ringRush()
	for p in players.iterate do p.kartRings = $ or 0 end
	
	local possiblePlayers = {}

	for p in players.iterate
		if validP(p) then table.insert(possiblePlayers, p.mo) end
	end
	
	if #possiblePlayers and (leveltime > 8*TICRATE)
		if not (leveltime%10)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local ring = P_SpawnMobj(tmo.x+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.y+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_KARTRING)
			ring.fuse = 30*TICRATE
		end
		
		if not (leveltime%300)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local ring = P_SpawnMobj(tmo.x+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.y+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_BIGRING)
			ring.fuse = 30*TICRATE
		end

		if not (leveltime%850)
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local item = P_SpawnMobj(tmo.x+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.y+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_RANDOMITEM)
			item.flags = $ & ~MF_NOGRAVITY & ~MF_NOCLIPHEIGHT & ~MF_SLIDEME
		end
	end
	
	if (leveltime == 8*TICRATE)
		server.ringTimer = 180*TICRATE
		S_ChangeMusic("RINGRS")
		showMusicCredit()
		
		for p in players.iterate
			p.kartRings = 0
		end
	end
	
	if not (leveltime%10)
		for p in players.iterate do p.marescore = p.kartRings end
	end
	
	if server.ringTimer
		server.ringTimer = $-1
		
		if server.ringTimer <= 0
			for p in players.iterate
				p.marescore = p.lightenergy
			end
			
			BX_EndBattle()
		end
	end
end

local function ringHUD(v, p, c)
	if server and server.ringTimer and p and p.valid and not p.spectator
		local t = server.ringTimer
		v.drawString(150, 0, G_TicsToMinutes(t)..":"..G_TicsToSeconds(t).." left", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
		v.drawString(150, 10, (tostring(p.kartRings) or "0").." rings", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
	end
	
	/*
	for mo in thinkers.iterate("mobj")
		if mo.type == MT_KARTRING or mo.type == MT_FLUNGRING
			v.drawOnMinimap(mo.x, mo.y, FRACUNIT, v.cachePatch("RINGMAP"))
		end
	end
	*/
end

local function ringHurt(p, inf, src)
	if p.mo and p.mo.valid
		local ringLoss = min(30, p.kartRings or 0)

		if ringLoss > 0
			for i = 1, ringLoss
				local ring = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + 4*FRACUNIT, MT_FLUNGRING)
				ring.pickupcool = 40
			
				P_InstaThrust(ring, P_RandomRange(1, 359)*ANG1, P_RandomRange(4, 25)*FRACUNIT)
				P_SetObjectMomZ(ring, P_RandomRange(2, 30)*FRACUNIT)
			end
			
			p.kartRings = max(0, $-ringLoss)
		end
	end
end

local function ringReset()
	server.ringTimer = nil
	
	for p in players.iterate
		p.kartRings = nil
	end
end

Box.Gamemodes[GM_RINGRUSH] = {
	name = "Ring Rush",
	hint = "Collect the most rings!",
	noBumpers = true,

	thinker = ringRush,
	hudfunc = ringHUD,
	spinoutfunc = ringHurt,
	squishfunc = ringHurt,
	explodefunc = ringHurt,
	resetfunc = ringReset,
}