Box.SimonSays = {
	[1] = {
		instruction = "Keep Driving",
		reactiontime = TICRATE,
		says = function(p)
			if (p.cmd.buttons & BT_ACCELERATE)
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if (p.cmd.buttons & BT_ACCELERATE)
				return false
			end
			
			return true
		end,
	},

	[2] = {
		instruction = "Reverse",
		reactiontime = TICRATE,
		says = function(p)
			if (p.cmd.buttons & BT_BRAKE)
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if (p.cmd.buttons & BT_BRAKE)
				return false
			end
			
			return true
		end,
	},

	[3] = {
		instruction = "Use Item",
		reactiontime = TICRATE+5,
		giveitem = 1,
		check = function(p)
			if p.kartstuff[k_sneakertimer]
				p.didboost = true
			end
		end,
		says = function(p)
			if p.didboost
				p.didboost = nil
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if p.didboost
				p.didboost = nil
				return false
			end
			
			return true
		end,
	},
	
	[4] = {
		instruction = 'Type "Respawn" in your console',
		reactiontime = 4*TICRATE,
		check = function(p)
			if p.playerstate == PST_DEAD
				p.didrespawn = true
			end
		end,
		says = function(p)
			if p.didrespawn
				p.didrespawn = nil
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if p.didrespawn
				p.didrespawn = nil
				return false
			end
			
			return true
		end,
	},
	
	[5] = {
		instruction = "Charge a drift spark",
		reactiontime = 3*TICRATE,
		check = function(p)
			if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)
				p.diddrift = true
			end
		end,
		says = function(p)
			if p.diddrift
				p.diddrift = nil
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if p.diddrift
				p.diddrift = nil
				return false
			end
			
			return true
		end,
	},

	[6] = {
		instruction = "Stop Moving",
		reactiontime = 2*TICRATE,
		says = function(p)
			if p.speed < 8*TICRATE
				return true
			end
			
			return false
		end,
		dontsay = function(p)
			if p.speed > 8*TICRATE
				return true
			end
			
			return false
		end,
	},

	[7] = {
		instruction = "Collide with someone or something.",
		reactiontime = 5*TICRATE,
		check = function(p)
			if (p.mo.eflags & MFE_JUSTBOUNCEDWALL)
			or p.kartstuff[k_justbumped]
				p.didbonk = true
			end
		end,
		says = function(p)
			if p.didbonk
				p.didbonk = nil
				return true
			end

			return false
		end,
		dontsay = function(p)
			if p.didbonk
				p.didbonk = nil
				return false
			end

			return true
		end,
	},
}

rawset(_G, "doSimonSays", function(num)
	S_StartSound(nil, sfx_kc48)
	
	for p in players.iterate
		if validP(p)
			p.kartstuff[k_driftcharge] = 0
			p.kartstuff[k_itemtype] = 0
			p.kartstuff[k_itemamount] = 0
			p.startang = p.mo.angle
		end
	end

	server.cursay = Box.SimonSays[tonumber(num)]
	server.doit = true
	if P_RandomChance(FRACUNIT/3)
		server.doit = false
	end
	
	if server.cursay.giveitem
		for p in players.iterate
			if validP(p)
				p.kartstuff[k_itemtype] = server.cursay.giveitem
				p.kartstuff[k_itemamount] = 1
			end
		end
	end
	
	local speedUp = 3
	speedUp = max(0, speedUp-server.simonsays)

	server.simontime = server.cursay.reactiontime + (speedUp*TICRATE)
	server.simonsays = $+1
end)

local function simonThinker()
	server.simonsays = $ or 0

	if leveltime > 8*TICRATE
		if (not (leveltime%350) and not server.cursay)
		or (leveltime == 10*TICRATE)
			doSimonSays(P_RandomRange(1, #Box.SimonSays))
		end
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("RINGRS")
		showMusicCredit()
	end

	if server.cursay and server.simontime
		if server.cursay.check
			for player in players.iterate
				if validP(player)
					server.cursay.check(player)
				end
			end
		end
		
		server.simontime = $-1
		if server.simontime <= 0
			for p in players.iterate
				if server.doit == true
					p.winsay = server.cursay.says(p)
				else
					p.winsay = server.cursay.dontsay(p)
				end
				
				if p.winsay == false and validP(p)
					p.boxdata.out = true
					p.boxdata.survivaltime = G_TicsToSeconds(leveltime-10*TICRATE)
					BX_ExplodeAndRespawn(p)
					
					print(p.name.." failed to follow instruction.")
				end
				
				p.winsay = nil
				p.startang = nil
			end
			
			server.cursay = nil
			server.simontime = nil
			server.doit = nil
			
			-- Now check for the players left
			local playersLeft = {}
			for p in players.iterate
				if validP(p)
					table.insert(playersLeft, p)
				end
			end
			
			server.ended = $ or false
			if #playersLeft <= 1 and server.ended == false
				for p in players.iterate
					if not p.spectator
						if p.boxdata.out == true
							p.marescore = p.boxdata.survivaltime or 0
						else
							p.marescore = 69420
						end
					end
				end
				
				BX_EndBattle()
				server.ended = true
			end
		end
	end
end

local function simonHud(v, p, c)
	if server and server.valid
		if server.cursay and server.simontime
			if server.doit == true
				v.drawString(160, 30, "SIMON SAYS", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
				v.drawString(160, 40, server.cursay.instruction.."("..G_TicsToSeconds(server.simontime)..")", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
			else
				v.drawString(160, 30, server.cursay.instruction.."("..G_TicsToSeconds(server.simontime)..")", V_SNAPTOTOP|V_SNAPTOLEFT, "center")
			end
		end
	end
end

local function simonReset()
	server.simonsays = nil
	server.cursay = nil
	server.simontime = nil
	server.doit = nil
end

Box.Gamemodes[GM_SIMONSAYS] = {
	name = "Simon Says",
	hint = "Follow ONLY Simon's instructions!",
	noBumpers = true,
	thinker = simonThinker,
	hudfunc = simonHud,
	resetfunc = simonReset,
}