freeslot("SPR_IMIT")

local function tagThinker()
	server.taggedShit = $ or {}
	server.timeLeft = $ or 180*TICRATE
	if (leveltime == 5*TICRATE) and not server.firstTagged
		local possibleP = {}
		for p in players.iterate
			if validP(p)
				table.insert(possibleP, p)
			end
		end
		
		server.timeLeft = 180*TICRATE
		
		server.firstTagged = possibleP[P_RandomRange(1, #possibleP)]
		server.firstTagged.tagged = true
		
		print(server.firstTagged.name.." is tagged! Run away from them to avoid being tagged.")
		table.insert(server.taggedShit, server.firstTagged)
	end
	
	-- tag implication
	local IT
	for p in players.iterate do
		if p.mo and p.mo.valid and p.tagged then
			IT = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z+p.mo.height, MT_THOK)
			IT.sprite = SPR_IMIT
			IT.frame = FF_FULLBRIGHT|A
			IT.fuse = 1
		end
	end
	
	if (leveltime == 8*TICRATE) then
		S_ChangeMusic("RINGRS")
		showMusicCredit()
	end
	
	-- items
	if not (leveltime%800)
		local possiblePlayers = {}

		for p in players.iterate
			if validP(p) then table.insert(possiblePlayers, p.mo) end
		end

		if #possiblePlayers
			local tmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local item = P_SpawnMobj(tmo.x+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.y+P_RandomRange(-3000, 3000)<<FRACBITS, tmo.ceilingz-P_RandomRange(0, 150)<<FRACBITS, MT_RANDOMITEM)
			item.flags = $ & ~MF_NOGRAVITY & ~MF_NOCLIPHEIGHT & ~MF_SLIDEME
		end
	end
	
	// End Conditions
	
	--when timer runs out
	if (leveltime > 7*TICRATE)
		server.timeLeft = $-1
		if server.timeLeft <= 0
			for p in players.iterate
				if not p.tagged
					p.marescore = 69420
				end
			end
			
			BX_EndBattle()
			return true
		end
	end

	-- when there's only 1 player left
	local unTaggedPlayers = {}
	for p in players.iterate
		if not p.tagged
			p.marescore = max(0, G_TicsToSeconds(leveltime-6*TICRATE))
			table.insert(unTaggedPlayers, p)
		end
	end

	server.ended = $ or false
	if #unTaggedPlayers <= 1 and server.ended == false
		unTaggedPlayers[1].marescore = 69420
		BX_EndBattle()
		server.ended = true
	end
end

local function tagPlayer(p, p2)
	if not p2 then return end
	if not p2.tagged then return end
	if p.tagged then return end
	
	p.tagged = true
	table.insert(server.taggedShit, p)
	print(p.name.." got tagged by "..p2.name.."!")
end

local function tagPain(p, inf, src)
	local p2
	if src and src.valid and src.player
		p2 = src.player
	elseif inf and inf.valid and inf.player
		p2 = inf.player
	end
	
	if not p2 then return false end
	if not p2.tagged then return false end
	tagPlayer(p, p2)
	
	return true
end

local function tagCollide(mo, mo2)
	if mo.player and mo2.player and mo.player.tagged and not mo2.player.tagged
		tagPlayer(mo.player, mo2.player)
		return true
	end
	
	return
end

local function tagHud(v, p, cam)
	for player in players.iterate
		if player.mo and player.mo.valid and player.tagged
			v.drawOnMinimap(player.mo.x, player.mo.y, FRACUNIT, v.cachePatch("YIKES"))
		end
	end
end

local function resetTag()
	server.firstTagged = nil
	server.timeLeft = nil
	server.taggedShit = nil
	
	for p in players.iterate
		if validP(p)
			p.tagged = nil
		end
	end
end

Box.Gamemodes[GM_TAG] = {
	name = "Tag",
	hint = "Don't get tagged, or tag the opponents!",
	noBumpers = true,

	thinker = tagThinker,
	hudfunc = tagHud,
	spinoutfunc = tagPain,
	squishfunc = tagPain,
	explodefunc = tagPain,
	collidefunc = tagCollide,
	resetfunc = resetTag,
}