rawset(_G, "randThemes", {
	{}, -- default, can be left empty
	{"GFZFLR02", R_TextureNumForName("GFZROCKB")},
	{"THZFLR08", R_TextureNumForName("THZ2N4")},
	{"DSZFLR10", R_TextureNumForName("DSZ11")},
	{"CEZFLR08", R_TextureNumForName("CASTLEA")}
})

addHook("MapLoad", function()
	if gamemap ~= 69 then return false end

	hud.enable("item")
	hud.enable("gametypeinfo")
	hud.enable("time")

	if server.gamemode and Box.Gamemodes[server.gamemode] and Box.Gamemodes[server.gamemode].resetfunc
		Box.Gamemodes[server.gamemode].resetfunc()
	end
	
	// select a random theme
	local theme = randThemes[P_RandomRange(1, #randThemes)]

	if theme[1] then
		for s in sectors.iterate do
			s.floorpic = theme[1]
			s.ceilingpic = theme[1]
		end
	end

	if theme[2] then
		for s in sides.iterate do
			s.toptexture = theme[2]
//			s.midtexture = theme[2]
			s.bottomtexture = theme[2]
		end
	end

	for p in players.iterate do
		if p.spectator then continue end

		p.boxdata = {
			out = false,
			survivaltime = 0,
		}

		p.mo.color = p.skincolor

		p.kartstuff[k_bumper] = 3
		p.kartstuff[k_itemtype] = 0
		p.kartstuff[k_itemamount] = 0

		-- someone got pissy about the weight stats so i went fuck it
		p.kartspeed = 5
		p.kartweight = 4
	end

	if gamemap == 69
		setGameMode()
	end
	
	server.ended = false
end)