addHook("ThinkFrame", function()
	if gamemap ~= 69 then return end

	-- Out Handling
	for p in players.iterate
		p.boxdata = $ or {
			out = false,
			survivaltime = 0,
		}
		
		if p.boxdata.out == true
			p.kartstuff[k_bumper] = 0

			if p.kartstuff[k_comebacktimer] then p.kartstuff[k_comebacktimer] = 3*TICRATE end
		end

		if server.gamemode and Box.Gamemodes[server.gamemode] and Box.Gamemodes[server.gamemode].teams then
			if p.team == "red"
				p.mo.color = SKINCOLOR_RED
			elseif p.team == "blue"
				p.mo.color = SKINCOLOR_BLUE
			elseif p.team == "green"
				p.mo.color = SKINCOLOR_GREEN
			elseif p.team == "yellow"
				p.mo.color = SKINCOLOR_YELLOW
			end
		end
	end

	-- Gamemode Thinkers
	if server.gamemode and Box.Gamemodes[server.gamemode] then
		local gamemode = Box.Gamemodes[server.gamemode]

		if gamemode.thinker then gamemode.thinker() end

		-- another check cause sometimes gamemodes just end
		if not gamemode then return end

		if gamemode.mobjthinker
			for mobj in mobjs.iterate()
				if mobj and mobj.valid
					gamemode.mobjthinker(mobj)
				end
			end
		end

		for p in players.iterate
			if validP(p)
				if gamemode.playerthinker 
					gamemode.playerthinker(p)
				end
				
				if server.gamemode and gamemode
					if gamemode.noBumpers
						p.kartstuff[k_bumper] = 10
					end
				end
			end
		end
	end
end)

-- Bumpers
addHook("MobjThinker", function(mo)
	if not G_BattleGametype() then return end

	if server.gamemode and Box.Gamemodes[server.gamemode]
		if Box.Gamemodes[server.gamemode].noBumpers
			mo.flags = $|MF2_DONTDRAW
		else
			mo.flags = $ & ~MF2_DONTDRAW
		end
	end
end, MT_BATTLEBUMPER)

-- Spinning, Squishing and Exploding. Also just general damage
addHook("PlayerSpin", function(p, inf, src)
	if gamemap ~= 69 then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		if Box.Gamemodes[server.gamemode].spinoutfunc 
			return Box.Gamemodes[server.gamemode].spinoutfunc(p, inf, src)
		end
	end
end)

addHook("PlayerSquish", function(p, inf, src)
	if gamemap ~= 69 then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		if Box.Gamemodes[server.gamemode].squishfunc 
			return Box.Gamemodes[server.gamemode].squishfunc(p, inf, src)
		end
	end
end)

addHook("PlayerExplode", function(p, inf, src)
	if gamemap ~= 69 then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		if Box.Gamemodes[server.gamemode].explodefunc
			return Box.Gamemodes[server.gamemode].explodefunc(p, inf, src)
		end
	end
end)

addHook("MobjDamage", function(mo, inf, src, dmg, dmgType)
	if gamemap ~= 69 then return end

	if mo.player and mo.player.valid
		local p = mo.player
		if server.gamemode and Box.Gamemodes[server.gamemode]
			if Box.Gamemodes[server.gamemode].damagefunc then 
				return Box.Gamemodes[server.gamemode].damagefunc(p, inf)
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldSpin", function(p, inf, src)
	if gamemap ~= 69 then return end
	if not G_BattleGametype() then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		local mode = Box.Gamemodes[server.gamemode]
		
		if mode.teams
			if src and src.player
				if p.team == src.player.team
					K_DoInstashield(p)
					return false
				end
			end
		end
		
		if mode.shouldspin
			return mode.shouldspin(p, inf, src)
		end
	end
end)

addHook("ShouldSquish", function(p, inf, src)
	if gamemap ~= 69 then return end
	if not G_BattleGametype() then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		local mode = Box.Gamemodes[server.gamemode]

		if mode.teams
			if src and src.player
				if p.team == src.player.team
					K_DoInstashield(p)
					return false
				end
			end
		end
		
		if mode.shouldsquish
			return mode.shouldsquish(p, inf, src)
		end
	end
end)

addHook("ShouldExplode", function(p, inf, src)
	if gamemap ~= 69 then return end
	if not G_BattleGametype() then return end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and validP(p)
		local mode = Box.Gamemodes[server.gamemode]
		
		if mode.teams
			if src and src.player
				if p.team == src.player.team
					K_DoInstashield(p)
					return false
				end
			end
		end

		if mode.shouldexplode
			return mode.shouldexplode(p, inf, src)
		end
	end
end)

addHook("MobjCollide", function(mo, mo2)
	if gamemap ~= 69 then return end
	if not G_BattleGametype() then return end
	
	if (mo.z >= mo2.z + mo2.height)
	or (mo.z + mo.height < mo2.z)
		return false
	end
	
	if server.gamemode and Box.Gamemodes[server.gamemode] and mo.valid and mo2.valid
		local mode = Box.Gamemodes[server.gamemode]

		if mode.collidefunc
			return mode.collidefunc(mo, mo2)
		end
	end
end, MT_PLAYER)

// HUD
hud.add(function(v, p, c)
	if not G_BattleGametype() then return end

	if validP(p) and server.gamemode and Box.Gamemodes[server.gamemode]
		local gamemode = Box.Gamemodes[server.gamemode]

		if (leveltime <= 210) then
			v.drawString(160, 20+FixedInt(8*sin(leveltime*ANG10)), "<"..gamemode.name..">", V_BLUEMAP|V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "center")
			v.drawString(160, 30+FixedInt(8*sin(leveltime*ANG10)), gamemode.hint, V_SNAPTOTOP|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "center")
		end

		if gamemode.hudfunc then gamemode.hudfunc(v, p, c) end
		
		if gamemode.noBumpers
			hud.disable("gametypeinfo")
			hud.disable("battlerankingsbumpers")
		else
			hud.enable("gametypeinfo")
			hud.enable("battlerankingsbumpers")
		end
	end
end, "game")

// Netvars can be placed in here
addHook("NetVars", function(x)
	Box.Teams = x($)
end)